unit Robot;
{(c) by DS-Company 1997 Daniel Schmidt}
interface
  procedure vor;
  procedure drehe_links;
  procedure gib_ab;
  procedure nimm_auf;
  function  vorne_frei:boolean;
  function  rechts_frei:boolean;
  function  links_frei:boolean;
  function  platz_belegt:boolean;
  function  hat_vorrat:boolean;
  procedure Lade_Feld;   {Neues Feld laden}
  procedure Speichere_Feld; {Speicher Feld ab}
  procedure Aendere_Feld; {es wird interaktiv jede
                           manuelle Aktion des Benutzers gemerkt}
  procedure Roboter_Schrittfolge; {die gemerkten Aktionen werden in eine
                                   Datei gespeichert}
  procedure Hauptmenu;
implementation
  uses crt,strings;
  const MinXLaenge=3; MinYLaenge=3;
        MaxXLaenge=38; MaxYLaenge=12;    {maximale Feldanzahl}
  var x,y:byte;          {aktuelle Positon}
      Richtung: record
        X,Y:integer;
      end;
      Feld:array[0..2*MaxXLaenge+2,0..2*MaxYLaenge+2] of byte; {Roboterfeld}
      XLaenge,YLaenge:integer;
      Vorrat:integer;           {Vorrat}
      Geschwindigkeit:word;     {Geschwindigkeit}

      DateiName:string;       {Name der Roberfeld-Datei}
      DateiName_Schrittfolge: string;
      Datei:text;             {Roboterfeld laden}
      DateiString:string[2*MaxXLaenge+1]; {Aufbau des Roboterfelds}
      Status: (Programm,Schrittfolge,FeldAendern,Menu);
      Error: string[50];
      s,ch:char;
      ax,ay:byte;             {vorherige Koordinaten}
      i,j,k:integer;          {Zaehlvariablen}

procedure Error_ausgeben;
  begin
    gotoxy(1,9);
    writeln(' ͻ');
    writeln('    ',Error:50,'                     ');
    writeln(' ','':75);
    writeln('    Die Macht war nicht mit Dir ! - Das Imperium feiert einen neuen Sieg   ');
    writeln(' ͼ');
    gotoxy(1,1);
    Sound(220); Delay(100); NoSound;
    ch:=readkey;
    if Schrittfolge=Schrittfolge then exit;
    halt(1);
  end;

procedure Feld_zeichnen; {gesamtes Feld zeichnen}
  begin
   clrscr;
   textcolor(lightgray);
   for j:=1 to 2*YLaenge+1 do
   begin
     for i:=1 to 2*XLaenge+1 do
     begin
       if Feld[i,j]=0 then write(' ')
       else if Feld[i,j]<100 then
       begin
         str(Feld[i,j],DateiString); textcolor(green);
         write(DateiString[length(DateiString)]); textcolor(lightgray);
       end
       else write( chr( Feld[ i, j] ) );
     end;
     if odd(j) then writeln else writeln(j div 2:2);
   end;
   writeln(copy(' 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0',1,XLaenge*2+1));
   gotoxy(1,25); textcolor(red);
   case Status of
    Schrittfolge:
   begin
     write('Manuelle Befehle speichern    ');
     textcolor(yellow);  write(copy(dateiname_Schrittfolge,1,12):12)
   end;
    Programm:
   begin
     write('R2-D2 gesteuert vom Programm:');
     textcolor(yellow);  write(copy(dateiname,1,12):12);
   end;
    else
   begin
     write('Feld fuer R2-D2 aendern      ');
     textcolor(yellow);  write(copy(dateiname,1,12):12);
   end;
   end;
   textcolor(red);
   write('  Position: X=    Y=     Vorrat:');
  end;

procedure Zeichnen;
  begin
  gotoxy(2*ax,2*ay); textcolor(green); {vorherige Postion zeichnen}
  if Feld[2*ax,2*ay]=0 then write(' ')
  else if Feld[2*ax,2*ay]<100 then begin
   str(Feld[2*ax,2*ay],DateiString); write(copy(DateiString,length(DateiString),1));
  end;
  ax:=x; ay:=y;
  gotoxy(2*x,2*y); textcolor(yellow);                {neue Position zeichnen}
  if (Richtung.X= 0) and (Richtung.Y=-1) then write('^');
  if (Richtung.X=-1) and (Richtung.Y= 0) then write('<');
  if (Richtung.X= 0) and (Richtung.Y= 1) then write('v');
  if (Richtung.X= 1) and (Richtung.Y= 0) then write('>');
  textcolor(yellow);
  gotoxy(57,25); write(x:2);
  gotoxy(63,25); write(y:2);
  gotoxy(75,25); write(Vorrat:2);
  end;

procedure Hilfe;
  begin
  clrscr;  textcolor(white);
  writeln('HILFE FUER DIE TASTEN-FUNKTION');
  case Status of
    Schrittfolge:
    begin
      writeln('R2-D2 bewegen durch Cursur-Tasten');
      writeln('                 Norden');
      writeln('                    ^');
      writeln('          Westen<       >Osten');
      writeln('                    v');
      writeln('                 Sueden');
      writeln('Objekte abgeben oder nehmen durch Tasten - oder +');
      writeln('Nach links drehen durch Taste 4')
    end;
    FeldAendern:
    begin
      writeln('Cursur bewegen durch Cursur-Tasten');
      writeln('                 Norden');
      writeln('                    ^');
      writeln('          Westen<       >Osten');
      writeln('                    v');
      writeln('                 Sueden');
      writeln('Waende hinbauen oder wehnehmen durch Tasten des Zehnerblocks');
      writeln('           NW    Nord     NO');
      writeln('               7   8   9');
      writeln('       West    4       6   Osten');
      writeln('               1   2   3');
      writeln('           SW    Sueden   SO');
      writeln('Objekte hinlegen oder wehnehmen durch Tasten + oder -');
      writeln('Vorrat festlegen durch Taste 5');
    end;
  end;
  writeln(^j^m,'Bitte Taste drueken !');
  ch:=readkey;
  Feld_Zeichnen;
  end;
procedure Roboterfeld_Waende;
  type TWaende = record oben,unten,rechts,links:boolean; end;
  const CFeld_Zeichen: array[1..15] of char=('','','','','','','','','','','','','','','');
        CFeld_Waende: array[1..15] of TWaende = (
      (oben: true ; unten: true  ; rechts: false ; links: false),
      (oben: true ; unten: false ; rechts: false ; links: false),
      (oben: false; unten: true  ; rechts: false ; links: false),
      (oben: true ; unten: true  ; rechts: false ; links: true ),
      (oben: false; unten: true  ; rechts: false ; links: true ),
      (oben: true ; unten: false ; rechts: true  ; links: false),
      (oben: true ; unten: false ; rechts: true  ; links: true ),
      (oben: false; unten: true  ; rechts: true  ; links: true ),
      (oben: true ; unten: true  ; rechts: true  ; links: false),
      (oben: false; unten: false ; rechts: true  ; links: true ),
      (oben: false; unten: false ; rechts: false ; links: true ),
      (oben: false; unten: false ; rechts: true  ; links: false),
      (oben: true ; unten: true  ; rechts: true  ; links: true ),
      (oben: true ; unten: false ; rechts: false ; links: true ),
      (oben: false; unten: true  ; rechts: true  ; links: false));
  begin
    if (odd(i) or odd(j)) and (Feld[ i, j ]>100)then
      for k:=1 to 15 do
        with CFeld_Waende[k] do
          if (oben =(Feld[ i  , j-1]>100)) and (unten =(Feld[ i , j+1]>100)) and
             (links=(Feld[ i-1, j  ]>100)) and (rechts=(Feld[i+1, j]>100)) then
              Feld[ i, j ]:= ord(CFeld_Zeichen[k]);
     if Feld[ i, j]=255 then Feld[ i,j ]:=ord('');
  end;

procedure Roboterfeld_Laden;
  begin
    clrscr;
    IF DateiName='' then
    begin
      x:=1; y:=1; Richtung.x:=1; Richtung.y:=0; Geschwindigkeit:=10;
      Vorrat:=5; XLaenge:=15; YLaenge:=10;
      for j:=1 to 2*YLaenge+1 do
        for i:=1 to 2*XLaenge+1 do
          if ( (i=1) or (i=2*XLaenge+1) or (j=1) or (j=2*YLaenge+1) ) then
            Feld[ i, j ]:=255
          else
            Feld[ i, j ]:=0;
    end
    else
    begin
    Assign(Datei,DateiName);
    {$I-}Reset(Datei);{$I+}
    IF IOReSult <> 0 then
    begin
     writeln('Das Imperium hat die Roboterfeld-Datei ',DateiName,' geloescht ! - Taste druecken');
     readkey;
     halt(1);
    end;
    repeat
      Readln(Datei,DateiString);
      if (strlen(@DateiString)<1) then
         Break;
      val( DateiString, i ,j );
      if j<>0 then
        case DateiString[1] of
        'N','n' : begin Richtung.X:= 0; Richtung.Y:=-1; end;
        'W','w' : begin Richtung.X:=-1; Richtung.Y:= 0; end;
        'S','s' : begin Richtung.X:= 0; Richtung.Y:= 1; end;
        'O','o' : begin Richtung.X:= 1; Richtung.Y:= 0; end;
        end
      else
        case s of
        'X','x': ax:=i;
        'Y','y': ay:=i;
        'V','v': Vorrat:=i;
        'G','g': Geschwindigkeit:= 1025-(i*100);
        end;
    until s in ['F','f'];
    val( copy(DateiString,1,2), i, j);
    if (j=0) and (i in [MinXLaenge..MaxXLaenge]) then XLaenge:=i else XLaenge:=15;
    val( copy(DateiString,4,2), i, j);
    if (j=0) and (i in [MinYLaenge..MaxYLaenge]) then YLaenge:=i else YLaenge:=10;
    x:=ax; y:=ay; FillChar( Feld, sizeof(Feld), 0 );
    for j:=1 to 2*YLaenge+1 do
    begin
      readln(Datei,DateiString);
      for i:=1 to 2*XLaenge+1 do
      begin
        if i<=length(DateiString) then
          case DateiString[i] of
            '#'       : Feld[ i, j ] := 255;
            ' '       : Feld[ i, j ] :=  0;
            #100..#199: Feld[ i, j ] := ord( DateiString[i] ) - 100;
          end;
        if ( (i=1) or (i=2*XLaenge+1) or (j=1) or (j=2*YLaenge+1) ) and (Feld[ i, j]=0) then
          Feld[ i, j ]:=255;
      end;
    end;
    Close(Datei);
    end;
    clrscr;
    for j:=1 to 2*YLaenge+1 do
      for i:=1 to 2*XLaenge+1 do
        Roboterfeld_Waende;
    Feld_zeichnen;
    Zeichnen;
    Error:='';
    Status:=Programm;
  end;

procedure Roboter_Schrittfolge;
  begin
    write('Dateinamen zum abspeichern > ');
    readln(DateiName_Schrittfolge);
    clrscr;
    Status:=Schrittfolge;
    Feld_Zeichnen;
    if DateiName_Schrittfolge='' then exit;
    assign( Datei, DateiName_Schrittfolge );
    rewrite( Datei);
    Geschwindigkeit:=10;
    writeln( Datei,'USES R2D2');
    writeln( Datei,'{Roboter-Simluation: Schrittfolge als Pascal-Quelltext}');
    writeln( Datei,'BEGIN');
    repeat
      Zeichnen;
      ch:=readkey;
      Error:='';
      case ch of
        #72,#75,#80,#77:
        begin
          case ch of
          #72: begin i:=0; j:=-1; end;
          #75: begin i:=-1;j:=0; end;
          #80: begin i:=0; j:=1; end;
          #77: begin i:=1; j:=0; end;
          end;
          if Feld[2*x+i,2*y+j]<=100 then
          begin
            k:=1;
            while not ((Richtung.X=i) and (Richtung.Y=j)) do
            begin
              drehe_links; writeln( datei, '  drehe_links;');
              k:=k+1;
            end;
            vor; writeln( datei, '  vor;');
          end;
        end;
        '4': begin drehe_links; writeln( datei, '  drehe_links;'); end;
        '-':
          if (Vorrat>0) and (Feld[2*x,2*y]<99) then
          begin
            gib_ab;
            writeln( datei, '  gib_ab;')
          end;
        '+':
          if (Vorrat<99) and (Feld[2*x,2*y]>0) then
          begin
            nimm_auf;
            writeln( datei, '  nimm_auf;')
          end;
      end;
    until (ch=#27) or (Error<>'');
    if Error<>'' then writeln( datei, '{ Error : ',Error,' }');
    writeln( Datei,'END.');
    close( Datei);
  end;

procedure Aendere_Feld;
  var AendernX,AendernY: byte;
  begin
    x := 1; y := 1;
    Status:=FeldAendern;
    Feld_zeichnen; Zeichnen;
    repeat
      gotoxy(2*x,2*y);  textcolor(red);
      Ch := readkey;
      case ch of
        #72: if y>1 then y:=y-1;
        #75: if x>1 then x:=x-1;
        #80: if y<YLaenge then y:=y+1;
        #77: if x<XLaenge then x:=x+1;
        '1','2','3','4','6','7','8','9':
        begin
          case ch of
          '7': begin i:=2*x-1; j:=2*y-1; end;
          '8': begin i:=2*x  ; j:=2*y-1; end;
          '9': begin i:=2*x+1; j:=2*y-1; end;
          '4': begin i:=2*x-1; j:=2*y  ; end;
          '6': begin i:=2*x+1; j:=2*y  ; end;
          '1': begin i:=2*x-1; j:=2*y+1; end;
          '2': begin i:=2*x  ; j:=2*y+1; end;
          '3': begin i:=2*x+1; j:=2*y+1; end;
          end;
          if (i>1) and (i<2*XLaenge+1) and (j>1) and (j<2*YLaenge+1) then
          begin
            if Feld[ i, j]>100 then Feld[ i, j]:=0 else Feld[ i,j]:=255;
            Roboterfeld_Waende;
          end;
        end;
        '+': if Feld[2*x,2*y] < 99 then Feld[2*x,2*y] := Feld[2*x,2*y] + 1 ;
        '-': if Feld[2*x,2*y] > 0  then Feld[2*x,2*y] := Feld[2*x,2*y] - 1 ;
        '5': repeat
               gotoxy(1,24); write('Vorrat ? ');
               readln(vorrat);
             until vorrat in [0..99];
        #59: Hilfe;
      end;
      if ch in ['1'..'9'] then Feld_zeichnen;
      Zeichnen;
    until ch=#27;
  end;

procedure Lade_Feld;
  begin
    write('Datei mit Roboterfeld laden > ');
    readln(Dateiname);
    Roboterfeld_Laden;
  end;

procedure Speichere_Feld;
  begin
    write('Datei mit Roboterfeld speichern ');
    readln(Dateiname);
    assign( datei, dateiname);
    rewrite( datei);
    writeln( datei, 'X-Position=',x);
    writeln( datei, 'Y-Position=',y);
    if richtung.x=0 then
    begin
      if   richtung.y=-1 then writeln(datei, 'Richtung=Norden')
                         else writeln(datei, 'Richtung=Sden')
    end
    else if Richtung.x=1 then writeln(datei, 'Richtung=Osten')
    else                     writeln(datei, 'Richtung=Westen');
    writeln(datei, 'Geschwindigkeit=',geschwindigkeit);
    DateiString:='';
    str( XLaenge, DateiString);
    write(datei, 'Feld=',Dateistring,'x');
    if DateiString[0]=#1 then Dateistring:='0'+Dateistring;
    DateiString:='';
    str( XLaenge, DateiString);
    if DateiString[0]=#1 then Dateistring:='0'+Dateistring;
    writeln(datei, Dateistring);
    for j:=1 to 2*YLaenge+1 do
    begin
      DateiString:='';
      for i:=1 to 2*XLaenge+1 do
        case Feld[ i, j] of
        0    : dateistring:=dateistring+' ';
        1..99: dateistring:=dateistring+chr(Feld[i,j]+100);
        else   dateistring:=dateistring+'#';
        end;
        if Feld[ i, j]>0 then dateistring:=dateistring+'#'
        else dateistring:=dateistring+' ';
      writeln( datei, dateistring);
     end;
    close(datei);
  end;
procedure HauptMenu;
  const Menu_Inhalt: array[1..5] of string[50] =
        ('Roboter-Feld laden             '
        ,'Roboterfeld speichern          '
        ,'Roboterfeld aendern            '
        ,'Manuelle Schrittfolge speichern'
        ,'Ende                           ');
  begin
    repeat
      textcolor(white);
      k:=1;
      clrscr;
      textcolor(7);
      writeln('                                     Es war');
      writeln('                                einmal vor vielen,');
      writeln('                             vielen Jahren in einer');
      writeln('                          sehr weit entfernten Galaxi ...',^j^m);
      writeln('                    Nicht nur Luke Skiwalker sondern auch kleine');
      writeln('              Persoenlickeiten wie R2-D2 und sein Kumpel CH3PO erweisen');
      writeln('         sich im Kampf gegen Darw Weder und den Imperator als wahre Helden.',^j^m);
      textcolor(white);
      writeln('      Deine Aufgabe ist es R2-D2 durch die Deuterium-Minen von Rewalo 6 zu');
      writeln('     fuehren. R2-D2 darf nicht gegen die Waende laufen und kann maximal 99');
      writeln('    Deuterium-Objekte einsammeln. In verschiedenen Missionen muss unser Held');
      writeln('   Gaenge abforschen und Deuterium-Staebe von Ort zu Ort transportieren.',^j^m);
      writeln('                      Moege die Macht mit Dir sein !',^j^m,^j^m);
      writeln('                       M E N U    V O N   R 2 - D 2');
      textcolor(yellow);
      repeat
        gotoxy(1,20);
        for i:=1 to 5 do
        begin
          write('':22);
          if i=k then textbackground(red) else textbackground(0);
          writeln(Menu_inhalt[i]);
          textbackground(0);
        end;
        ch:=readkey;
        if ch=#0 then ch:=readkey;
        case ch of
          #72: if k>1 then dec(k);
          #80: if k<5 then inc(k);
        end;
     until ch=#13;
     textcolor(white);
     case k of
       1: Lade_Feld;
       2: Speichere_Feld;
       3: begin Aendere_Feld; k:=3; end;
       4: begin Roboter_schrittfolge; k:=4; end;
     end;
   until k=5;
  end;
procedure Steuerung;
  begin
  if Error<>'' then error_ausgeben;
  if keypressed then
  begin
    ch:=readkey;
    if ch=#27 then halt(1) else if readkey=#59 then Hilfe;
  end;
  delay(Geschwindigkeit);
  end;

procedure vor;
  begin
    if Feld[2*x+Richtung.X,2*y+Richtung.Y]>100 then Error:='R2-D2 ist gegen die Wand gelaufen !';
    Steuerung;
    x:=x+Richtung.X; y:=y+Richtung.Y;
    Zeichnen;
  end;

procedure drehe_links;
  begin
    Steuerung;
    if Richtung.X=0 then
     begin
      if Richtung.Y=-1 then Richtung.X:=-1;
      if Richtung.Y= 1 then Richtung.X:=1;
      Richtung.Y:=0;
     end
    else if Richtung.X=-1 then
     begin
      Richtung.X:=0; Richtung.Y:= 1;
    end
    else if Richtung.X= 1 then
      begin
      Richtung.X:=0; Richtung.Y:=-1;
    end;
    Zeichnen;
  end;

procedure Gib_ab;
  begin
    if (Vorrat=0) or (Feld[2*x,2*y]=99) then error:='R2-D2 kann nicht mehr Objekte abgeben';
    Steuerung;
    Vorrat:=Vorrat-1; Feld[2*x,2*y]:=Feld[2*x,2*y]+1;
    Zeichnen;
  end;

procedure Nimm_auf;
  begin
    if Feld[2*x,2*y]=0 then error:='R2-D2 kann an der aktuellen Position kein Objekt finden';
    Steuerung;
    Feld[2*x,2*y]:=Feld[2*x,2*y]-1;
    Vorrat:=Vorrat+1;
    Zeichnen;
  end;

function vorne_frei:boolean;
  begin
  vorne_frei := ( Feld[2*x+Richtung.X,2*y+Richtung.Y]<100 );
  end;
function links_frei:boolean;
  begin
    if (Richtung.X= 0) and (Richtung.Y=-1) then links_frei := ( Feld[2*x-1,2*y+0] < 100 );
    if (Richtung.X=-1) and (Richtung.Y= 0) then links_frei := ( Feld[2*x+0,2*y+1]<100 );
    if (Richtung.X= 0) and (Richtung.Y= 1) then links_frei := ( Feld[2*x+1,2*y+0]<100 );
    if (Richtung.X= 1) and (Richtung.Y= 0) then links_frei := ( Feld[2*x+0,2*y-1]<100 );
  end;
function rechts_frei:boolean;
  begin
    if (Richtung.X= 0) and (Richtung.Y=-1) then rechts_frei := ( Feld[2*x+1,2*y+0]<100  );
    if (Richtung.X=-1) and (Richtung.Y= 0) then rechts_frei := ( Feld[2*x+0,2*y-1]<100 );
    if (Richtung.X= 0) and (Richtung.Y= 1) then rechts_frei := ( Feld[2*x-1,2*y+0]<100 );
    if (Richtung.X= 1) and (Richtung.Y= 0) then rechts_frei := ( Feld[2*x+0,2*y+1]<100 );
  end;

function platz_belegt:boolean;
  begin
    platz_belegt := ( Feld[2*x,2*y]>0 );
  end;
function hat_vorrat:boolean;
  begin
    hat_vorrat := ( Vorrat>0 );
  end;

begin
  Roboterfeld_Laden;
end.